
/*
 * Tris Debug Program
 */

using System;
using System.IO;
using System.Timers;

namespace tris_is_package
{
    class Program
	{
		public static void Main(string[] args)
		{
	        tris_is_overloading_debug nm = new tris_is_overloading_debug();
		    nm.running();
		}
	}
	class tris_is_overloading_debug
	{
	    //Definition
		const int D_RIGHT =2000;
		const int D_LEFT =2001;
		const int D_DOWN =2002;
		const int MAPY =18;
		const int MAPX =18;
		const int MAXDESIGNARR=4;
		const int MAXDESIGN=7;
	    //Properties
		int rc;
		int xpos,ypos;
		int[,] tris = new int[MAPY,MAPX];
		int[,] design = new int[MAXDESIGNARR,MAXDESIGNARR];
		int[,,] realdesign = new int[,,]
        {
            {{0,1,0,0},{0,1,0,0},{0,1,0,0},{0,1,0,0}},
            {{0,0,0,0},{0,1,1,0},{0,1,1,0},{0,0,0,0}},
            {{0,0,0,0},{0,1,0,0},{1,1,1,0},{0,0,0,0}},
            {{0,0,1,0},{0,1,1,0},{0,1,0,0},{0,0,0,0}},
            {{0,1,0,0},{0,1,1,0},{0,0,1,0},{0,0,0,0}},
            {{0,0,0,0},{0,1,0,0},{0,1,1,1},{0,0,0,0}},
            {{0,0,0,0},{0,1,1,1},{0,1,0,0},{0,0,0,0}}
        };
		
		DateTime nw;
		Timer tm;
		ConsoleKeyInfo keyinfo;
		
		//Method
		public tris_is_overloading_debug(){}
		public void running()
		{
		    init();
			
			while(true)
			{
			    keyinfo=Console.ReadKey(true);
				
				if(keyinfo.Key==ConsoleKey.RightArrow)
				{
				    rc=check_t_tris(D_RIGHT,ref ypos,ref xpos);
					if(rc != 0){stop(); Environment.Exit(0);}
				}
				if(keyinfo.Key==ConsoleKey.LeftArrow)
				{
				    rc=check_t_tris(D_LEFT,ref ypos,ref xpos);
					if(rc != 0){stop(); Environment.Exit(0);}
				}
				if(keyinfo.Key==ConsoleKey.DownArrow)
				{
				    rc=check_t_tris(D_DOWN,ref ypos,ref xpos);
					if(rc != 0){stop(); Environment.Exit(0);}
				}
				if(keyinfo.Key==ConsoleKey.Escape) break;
				
				logg("Key", keyinfo);
			}
			
			stop();
		}
		void init()
		{
			int ii,kk,ff;
			//design init
			Random ____rr = new Random();
            ff = ____rr.Next() % MAXDESIGN;
			
			Console.WriteLine("----");
			for(ii=0; ii<MAXDESIGNARR; ii++)
			{
			    for(kk=0; kk<MAXDESIGNARR; kk++)
			    {
			        design[ii,kk]=realdesign[ff,ii,kk];
					
					if(design[ii,kk]==1) Console.Write("H");
					else Console.Write(" ");
				}
				if(ii==MAXDESIGNARR-1)
				{
					Console.Write("\n");
					Console.WriteLine("----");
				}
				else Console.WriteLine("");
			}
			
			//xpos,ypos init
			xpos = MAPX/2;
			ypos = 0;
			
			//tris all init
			for(ii=0; ii<MAPY; ii++)
			{
				for(kk=0; kk<MAPX; kk++)
				{
					tris[ii,kk]=0;
				}
		    }
			//tris vertical init
			for(ii=0; ii<MAPY; ii++)
			{
				tris[ii,0]=1;
				tris[ii,MAPX-1]=1;
			}
			//tris horizontal init
			for(kk=0; kk<MAPX; kk++)
			{
				tris[MAPY-1,kk]=1;
			}
			
			//timer init
			tm = new Timer();
			tm.Elapsed += new ElapsedEventHandler(____time_tick_1);
			tm.Interval = 1000;
			tm.Start();
			
			logg("Start");
		}
		void stop()
		{
			tm.Stop();
			tm.Elapsed -= ____time_tick_1;
			
			logg("Stop");
		}
		int check_t_tris(int direction, ref int y, ref int x)
		{
			int ii,kk,ff;
			int[,] tristmp = new int[MAPY,MAPX];
			
			if(direction==D_RIGHT) x++;
			if(direction==D_LEFT) x--;
			if(direction==D_DOWN) y++;
			
			for(ii=0; ii<MAPY; ii++)
			{
				for(kk=0; kk<MAPX; kk++)
				{
					tristmp[ii,kk]=tris[ii,kk];
				}
			}
			logg("A", true);
			
			for(ii=0; ii<MAXDESIGNARR; ii++)
			{
				for(kk=0; kk<MAXDESIGNARR; kk++)
				{
					if(y+ii==MAPY-1) break;
					if(x+kk==0) break;
					if(x+kk==MAPX-1) break;
					
					if(design[ii,kk]==1) tristmp[y+ii,x+kk]=0;
				}
				if(y+ii==MAPY-1) break;
				if(x+kk==0) break;
				if(x+kk==MAPX-1) break;
			}
			logg("B", true);
			
			ff=0;
			for(ii=0; ii<MAXDESIGNARR; ii++)
			{
				for(kk=0; kk<MAXDESIGNARR; kk++)
				{
					if(design[ii,kk]+tristmp[y+ii,x+kk]>1)
					{
						ff=100;
						break;
					}
				}
				if(ff==100) break;
			}
			logg("C", true);
			
			//fail
			if(ff==100)
			{
				if(direction==D_RIGHT) x--;
			    if(direction==D_LEFT) x++;
			    if(direction==D_DOWN) y--;
				
				return(-1);
			}
			logg("D", true);
			
			//succ
			for(ii=0; ii<MAXDESIGNARR; ii++)
			{
				for(kk=0; kk<MAXDESIGNARR; kk++)
				{
					if(design[ii,kk]==1) tristmp[y+ii,x+kk]=1;
				}
			}
			logg("E", true);
			
			for(ii=0; ii<MAPY; ii++)
			{
				for(kk=0; kk<MAPX; kk++)
				{
					tris[ii,kk]=tristmp[ii,kk];
				}
			}
			logg("F", true);
			
			return(0);
		}
		void ____time_tick_1(object sender, ElapsedEventArgs e)
		{
			rc=check_t_tris(D_DOWN,ref ypos,ref xpos);
			if(rc != 0)
			{
				stop(); 
				Environment.Exit(0);
			}
			
			logg("Timer");
		}
		//overloading
		void logg(string msg)
		{
			nw=DateTime.Now;
			
			Console.WriteLine(">>Pos:[" + ypos.ToString("000") + "," + xpos.ToString("000") + "]" +
			" Event:" + msg);
		}
		void logg(string msg, ConsoleKeyInfo keytmp)
		{
			nw=DateTime.Now;
			
			Console.WriteLine(">>Pos:[" + ypos.ToString("000") + "," + xpos.ToString("000") + "]" +
		    " KeyName:[" + keytmp.Key.ToString() + "]" +
			" Event:" + msg);
		}
		void logg(string msg, bool idx)
		{
			nw=DateTime.Now;
		    Console.Write("[" + msg + "]");
		}
	}
}




	